## buildbox 1.3.53

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(buildbox VERSION 1.3.53 LANGUAGES CXX)

set(TOOLS "ON" CACHE STRING "Build and test tools")
set_property(CACHE TOOLS PROPERTY STRINGS "ON" "OFF")

set(CASD "AUTO" CACHE STRING "Build and test buildbox-casd")
set_property(CACHE CASD PROPERTY STRINGS "AUTO" "ON" "OFF")

set(CASD_WRAP "AUTO" CACHE STRING "Build and test buildbox-casd-wrap")
set_property(CACHE CASD_WRAP PROPERTY STRINGS "AUTO" "ON" "OFF")

set(CASDOWNLOAD "AUTO" CACHE STRING "Build and test casdownload")
set_property(CACHE CASDOWNLOAD PROPERTY STRINGS "AUTO" "ON" "OFF")

set(CASUPLOAD "AUTO" CACHE STRING "Build and test casupload")
set_property(CACHE CASUPLOAD PROPERTY STRINGS "AUTO" "ON" "OFF")

set(CASUPLOAD_OCI "AUTO" CACHE STRING "Build and test casupload-oci")
set_property(CACHE CASUPLOAD_OCI PROPERTY STRINGS "AUTO" "ON" "OFF")

set(FUSE "AUTO" CACHE STRING "Build and test buildbox-fuse (only on Linux unless overridden)")
set_property(CACHE FUSE PROPERTY STRINGS "AUTO" "ON" "OFF")

set(LOGSTREAMRECEIVER "AUTO" CACHE STRING "Build and test logstreamreceiver")
set_property(CACHE LOGSTREAMRECEIVER PROPERTY STRINGS "AUTO" "ON" "OFF")

set(LOGSTREAMTAIL "AUTO" CACHE STRING "Build and test logstreamtail")
set_property(CACHE LOGSTREAMTAIL PROPERTY STRINGS "AUTO" "ON" "OFF")

option(OCI "Build and test OCI support (requires CURL and nlohmann-json)" ON)

set(OUTPUTSTREAMER "AUTO" CACHE STRING "Build and test outputstreamer")
set_property(CACHE OUTPUTSTREAMER PROPERTY STRINGS "AUTO" "ON" "OFF")

set(PLATFORM_COMPILER "AUTO" CACHE STRING "Default compiler of the platform")
set_property(CACHE PLATFORM_COMPILER PROPERTY STRINGS "AUTO" "gcc" "clang" "CC")

set(RECC "AUTO" CACHE STRING "Build and test recc")
set_property(CACHE RECC PROPERTY STRINGS "AUTO" "ON" "OFF")

set(REXPLORER "AUTO" CACHE STRING "Build and test rexplorer")
set_property(CACHE REXPLORER PROPERTY STRINGS "AUTO" "ON" "OFF")

set(RUMBAD "AUTO" CACHE STRING "Build and test rumbad")
set_property(CACHE RUMBAD PROPERTY STRINGS "AUTO" "ON" "OFF")

set(RUN_BUBBLEWRAP "AUTO" CACHE STRING "Build and test buildbox-run-bubblewrap (only on Linux unless overridden)")
set_property(CACHE RUN_BUBBLEWRAP PROPERTY STRINGS "AUTO" "ON" "OFF")

set(RUN_HOSTTOOLS "AUTO" CACHE STRING "Build and test buildbox-run-hosttools")
set_property(CACHE RUN_HOSTTOOLS PROPERTY STRINGS "AUTO" "ON" "OFF")

set(RUN_OCI "AUTO" CACHE STRING "Build and test buildbox-run-oci (only on Linux unless overridden)")
set_property(CACHE RUN_OCI PROPERTY STRINGS "AUTO" "ON" "OFF")

set(RUN_SYMLINK "AUTO" CACHE STRING "Target of buildbox-run symlink")
set_property(CACHE RUN_SYMLINK PROPERTY STRINGS "AUTO" "bubblewrap" "hosttools" "oci" "userchroot" "OFF")

set(RUN_USERCHROOT "AUTO" CACHE STRING "Build and test buildbox-run-userchroot")
set_property(CACHE RUN_USERCHROOT PROPERTY STRINGS "AUTO" "ON" "OFF")

set(TREXE "AUTO" CACHE STRING "Build and test trexe")
set_property(CACHE TREXE PROPERTY STRINGS "AUTO" "ON" "OFF")

set(WORKER "AUTO" CACHE STRING "Build and test buildbox-worker")
set_property(CACHE WORKER PROPERTY STRINGS "AUTO" "ON" "OFF")

option(BUILD_MOSTLY_STATIC "Build statically (as static as the platform allows)")
if(BUILD_MOSTLY_STATIC)
  set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
endif()

option(HARDEN "Enable hardening")
if(HARDEN)
  add_compile_options(-O1 -D_FORTIFY_SOURCE=2)
endif()

# Add ASAN option
option(ASAN "Enable AddressSanitizer")
if(ASAN)
  message(STATUS "Building with AddressSanitizer")
  add_compile_options(-fsanitize=address)
  add_link_options(-fsanitize=address)
endif()

if(NOT BUILDBOX_VERSION)
  find_program(GIT git)

  if(GIT STREQUAL "GIT-NOTFOUND")
    set(BUILDBOX_VERSION ${CMAKE_PROJECT_VERSION})
    message("Could not find git, setting version to 'CMAKE_PROJECT_VERSION'")
  elseif(NOT EXISTS "${CMAKE_SOURCE_DIR}/.git")
    set(BUILDBOX_VERSION ${CMAKE_PROJECT_VERSION})
    message("Not in a git repository, setting version to 'CMAKE_PROJECT_VERSION'")
  else()
    execute_process(
            COMMAND "git" "describe" "--tags"
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE BUILDBOX_VERSION
            OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Using git tag as version: ${BUILDBOX_VERSION}")
  endif()
endif()

include(CMakeFindDependencyMacro)
include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)

find_package(OpenSSL REQUIRED)
set(OPENSSL_TARGET OpenSSL::Crypto)

include("${CMAKE_SOURCE_DIR}/cmake/BuildboxCommonConfig.cmake")

add_subdirectory(protos)

include_directories("common")
include_directories("commonmetrics")
include_directories(${PROTO_GEN_DIR})

# Define 64-bit interface as default, required on 32-bit platforms,
# no effect on 64-bit platforms.
add_compile_options(-D_FILE_OFFSET_BITS=64)

if(${PLATFORM_COMPILER} STREQUAL "AUTO")
  if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
    set(PLATFORM_COMPILER "CC")
  elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(PLATFORM_COMPILER "gcc")
  elseif(CMAKE_SYSTEM_NAME MATCHES "Darwin")
    set(PLATFORM_COMPILER "clang")
  else()
    set(PLATFORM_COMPILER "unknown")
  endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "SunOS" AND CMAKE_CXX_COMPILER_ID STREQUAL GNU)
  if(BUILD_MOSTLY_STATIC AND NOT ${PLATFORM_COMPILER} STREQUAL "gcc")
    # Statically link to gcc libraries when building BuildBox with gcc
    # while gcc is not configured as default compiler on the platform.
    add_compile_options(-static-libgcc -static-libstdc++)
    add_link_options(-static-libgcc -static-libstdc++)
  endif()
endif()

include("${CMAKE_SOURCE_DIR}/cmake/check_protobuf_print_options.cmake")

include(CTest)
if(BUILD_TESTING)
  include_directories(third_party/grpc/include)
endif()
include_directories(third_party/ThreadPool)

add_subdirectory(common)
add_subdirectory(commonmetrics)

function(enable_tool TOOL_DIR TOOL_VAR)
  if((${TOOLS} STREQUAL "ON" AND ${TOOL_VAR} STREQUAL "AUTO") OR ${TOOL_VAR} STREQUAL "ON")
    add_subdirectory(${TOOL_DIR})
  endif()
endfunction()

function(enable_linux_tool TOOL_DIR TOOL_VAR)
  if((${TOOLS} STREQUAL "ON" AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND ${TOOL_VAR} STREQUAL "AUTO")
            OR ${TOOL_VAR} STREQUAL "ON")
    add_subdirectory(${TOOL_DIR})
  endif()
endfunction()

if(NOT OCI)
  if(${CASUPLOAD_OCI} STREQUAL "AUTO")
    set(CASUPLOAD_OCI "OFF")
  elseif(${CASUPLOAD_OCI} STREQUAL "ON")
    message(FATAL_ERROR "CASUPLOAD_OCI cannot be enabled if OCI is disabled")
  endif()
endif()

enable_tool(casd ${CASD})
enable_tool(casd-wrap ${CASD_WRAP})
enable_tool(casdownload ${CASDOWNLOAD})
enable_tool(casupload ${CASUPLOAD})
enable_tool(casupload-oci ${CASUPLOAD_OCI})
enable_linux_tool(fuse ${FUSE})
enable_tool(logstreamreceiver ${LOGSTREAMRECEIVER})
enable_tool(logstreamtail ${LOGSTREAMTAIL})
enable_tool(outputstreamer ${OUTPUTSTREAMER})
enable_tool(recc ${RECC})
enable_tool(rexplorer ${REXPLORER})
enable_tool(rumbad ${RUMBAD})
enable_linux_tool(run-bubblewrap ${RUN_BUBBLEWRAP})
enable_tool(run-hosttools ${RUN_HOSTTOOLS})
enable_linux_tool(run-oci ${RUN_OCI})
enable_tool(run-userchroot ${RUN_USERCHROOT})
enable_tool(trexe ${TREXE})
enable_tool(worker ${WORKER})

if(${RUN_SYMLINK} STREQUAL "AUTO")
  if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND TARGET buildbox-run-bubblewrap)
    set(RUN_SYMLINK "bubblewrap")
  else()
    set(RUN_SYMLINK "OFF")
  endif()
endif()

if(NOT ${RUN_SYMLINK} STREQUAL "OFF")
  if(NOT TARGET buildbox-run-${RUN_SYMLINK})
    message(FATAL_ERROR "RUN_SYMLINK is set to an unknown or disabled runner: ${RUN_SYMLINK}")
  endif()
  add_custom_target(buildbox-run ALL COMMAND ${CMAKE_COMMAND} -E create_symlink buildbox-run-${RUN_SYMLINK} buildbox-run)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/buildbox-run DESTINATION bin)
endif()

=== casd-wrap/CMakeLists.txt ===
FILE(GLOB SRCS *.cpp)

add_executable(buildbox-casd-wrap ${SRCS})
target_precompile_headers(buildbox-casd-wrap REUSE_FROM common)
target_link_libraries(buildbox-casd-wrap common)

install(TARGETS buildbox-casd-wrap RUNTIME DESTINATION bin)

=== casd/CMakeLists.txt ===
file(GLOB SRCS *.cpp)

add_library(casd STATIC ${SRCS})
target_precompile_headers(casd REUSE_FROM common)
target_link_libraries(casd common commonmetrics)

add_executable(buildbox-casd bin/buildboxcasd.m.cpp)
target_precompile_headers(buildbox-casd REUSE_FROM common)
target_link_libraries(buildbox-casd casd)
target_include_directories(buildbox-casd PRIVATE ".")
install(TARGETS buildbox-casd RUNTIME DESTINATION bin)

add_subdirectory(test)

option(CASD_BUILD_BENCHMARK "Build benchmarks" ON)
if(CASD_BUILD_BENCHMARK)
    add_subdirectory(benchmark)
endif()
target_include_directories(casd PUBLIC ".")

=== casdownload/CMakeLists.txt ===
add_executable(casdownload casdownload.m.cpp processargs.cpp)
target_precompile_headers(casdownload REUSE_FROM common)
target_include_directories(casdownload PRIVATE ".")
target_link_libraries(casdownload common)
install(TARGETS casdownload RUNTIME DESTINATION bin COMPONENT casdownload)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== casupload-oci/CMakeLists.txt ===
add_executable(casupload-oci casupload-oci.m.cpp processargs.h processargs.cpp)
target_precompile_headers(casupload-oci REUSE_FROM common)
target_include_directories(casupload-oci PRIVATE ".")
target_link_libraries(casupload-oci common)
install(TARGETS casupload-oci RUNTIME DESTINATION bin COMPONENT casupload-oci)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== casupload/CMakeLists.txt ===
add_executable(casupload casupload.m.cpp processargs.h processargs.cpp)
target_precompile_headers(casupload REUSE_FROM common)
target_include_directories(casupload PRIVATE ".")
target_link_libraries(casupload common)
install(TARGETS casupload RUNTIME DESTINATION bin COMPONENT casupload)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== common/CMakeLists.txt ===
include(CheckSymbolExists)

file(GLOB SRCS "*.cpp")

if(NOT OCI)
  file(GLOB OCI_SRCS "buildboxcommon_httpclient.cpp" "buildboxcommon_ociclient.cpp" "buildboxcommon_ocimanifest.cpp")
  list(REMOVE_ITEM SRCS ${OCI_SRCS})
endif()

set_source_files_properties(buildboxcommon_version.cpp PROPERTIES COMPILE_DEFINITIONS BUILDBOX_VERSION="${BUILDBOX_VERSION}")

set_source_files_properties(${PROTO_GENERATED_SRCS} PROPERTIES COMPILE_FLAGS "-Wno-error -Wno-conversion")
set_source_files_properties(${PROTO_GENERATED_SRCS} PROPERTIES GENERATED 1)

add_library(common STATIC
    ${SRCS}
    ${PROTO_GENERATED_SRCS})

target_precompile_headers(common PRIVATE buildboxcommon_deps.h)

target_link_libraries(common
    Threads::Threads
    ${PROTOBUF_TARGET}
    ${GRPC_TARGET}
    ${OPENSSL_TARGET}
    ${GLOG_TARGET}
    ${CURL_TARGET}
    commonmetrics
)

if(NOT APPLE)
  # macOS includes UUID generation functionality in libc, but on other platforms
  # it's a separate library.
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(uuid REQUIRED IMPORTED_TARGET uuid)
  target_link_libraries(common PkgConfig::uuid)
endif()

target_include_directories(common PRIVATE .)

target_compile_features(common PUBLIC cxx_std_20)

set(PUBLIC_FLAGS -Wall -Wformat-security)

# Compiler flags that apply only to the buildbox-common library.
# TODO: Move these additional warning flags to public flags once
# the other BuildBox components can be built with them.
set(PRIVATE_FLAGS -Wextra -pedantic-errors -Wno-vla -Wconversion -Wno-sign-conversion)

check_cxx_compiler_flag(-ftrivial-auto-var-init=pattern COMPILER_SUPPORTS_TRIVIAL_AUTO_VAR_INIT_PATTERN)
check_cxx_compiler_flag(-ftrivial-auto-var-init=zero COMPILER_SUPPORTS_TRIVIAL_AUTO_VAR_INIT_ZERO)

if(CMAKE_BUILD_TYPE STREQUAL "DEBUG")
  # Compiler flags for debug builds of all BuildBox components.
  set(DEBUG_FLAGS -Werror)

  if(COMPILER_SUPPORTS_TRIVIAL_AUTO_VAR_INIT_PATTERN)
    set(DEBUG_FLAGS ${DEBUG_FLAGS} -ftrivial-auto-var-init=pattern)
  endif()
else()
  # Compiler flags for release builds of all BuildBox components
  if(COMPILER_SUPPORTS_TRIVIAL_AUTO_VAR_INIT_ZERO)
    set(PUBLIC_FLAGS ${PUBLIC_FLAGS} -ftrivial-auto-var-init=zero)
  endif()
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL Clang OR CMAKE_CXX_COMPILER_ID STREQUAL AppleClang)
  set(PUBLIC_FLAGS ${PUBLIC_FLAGS} -Wno-vla-cxx-extension -Wno-nullability-completeness -Wno-nullability-extension)
  set(PRIVATE_FLAGS ${PRIVATE_FLAGS} -Xclang -fno-pch-timestamp -Winconsistent-missing-override)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
  set(PRIVATE_FLAGS ${PRIVATE_FLAGS} -Wsuggest-override)
endif()

target_compile_options(common PUBLIC ${PUBLIC_FLAGS} ${DEBUG_FLAGS} PRIVATE ${PRIVATE_FLAGS})

target_include_directories(common SYSTEM PRIVATE ${PROTO_GEN_DIR})

if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

check_symbol_exists(pipe2 "unistd.h" HAVE_PIPE2)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT HAVE_PIPE2)
  # Sanity check to always build with pipe2() on Linux as that's available
  # already since Linux 2.6.27 and glibc 2.9.
  message(FATAL_ERROR "pipe2() not found on Linux")
endif()
if(HAVE_PIPE2)
  target_compile_definitions(common PUBLIC HAVE_PIPE2)
endif()

add_dependencies(common generate_protobufs)

# Hash function used to calculate Digests.
# Integer value as defined in `enum DigestFunction.Value` in the REAPI proto
# (`protos/build/bazel/remote/execution/v2/remote_execution.proto`).
if(NOT BUILDBOXCOMMON_DIGEST_FUNCTION_VALUE)
  set(BUILDBOXCOMMON_DIGEST_FUNCTION_VALUE 1) # By default, use SHA-256
  message("`BUILDBOXCOMMON_DIGEST_FUNCTION_VALUE` not set, "
            "setting `DigestFunction.Value` to default value: 1 (SHA-256)")
else()
  message("Setting `DigestFunction.Value` to "
            "${BUILDBOXCOMMON_DIGEST_FUNCTION_VALUE}")
endif()

target_compile_definitions(common PUBLIC
    BUILDBOXCOMMON_DIGEST_FUNCTION_VALUE=${BUILDBOXCOMMON_DIGEST_FUNCTION_VALUE}
)

if(OCI)
  # Default OCI registry for OciClient
  if(NOT BUILDBOXCOMMON_DEFAULT_OCI_REGISTRY)
    set(BUILDBOXCOMMON_DEFAULT_OCI_REGISTRY "registry-1.docker.io") # By default, use docker.io
  else()
    message("Setting default OCI registry to "
              "${BUILDBOXCOMMON_DEFAULT_OCI_REGISTRY}")
  endif()

  target_compile_definitions(common PUBLIC
      BUILDBOXCOMMON_DEFAULT_OCI_REGISTRY="${BUILDBOXCOMMON_DEFAULT_OCI_REGISTRY}"
  )
endif()

include(CTest)
if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== commonmetrics/CMakeLists.txt ===
file(GLOB SRCS "*.cpp")

add_library(commonmetrics STATIC ${SRCS})

target_compile_features(commonmetrics PUBLIC cxx_std_20)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== fuse/CMakeLists.txt ===
pkg_check_modules(fuse REQUIRED IMPORTED_TARGET fuse3)

set(SRCS
    buildbox.cc
    client.cc
)

add_executable(buildbox-fuse ${SRCS})
target_precompile_headers(buildbox-fuse REUSE_FROM common)
target_include_directories(buildbox-fuse PRIVATE ".")
install(TARGETS buildbox-fuse RUNTIME DESTINATION bin)
target_link_libraries(buildbox-fuse
    PkgConfig::fuse
    common)

option(FUSE_TESTS_SKIP_REMOTE "Skip remote fuse tests")
option(FUSE_TESTS_SKIP_XATTR "Skip xattr fuse tests")
option(SKIP_BUILD_FUSE_CHMOD_PERMS "Skip building the chmod_perms test")

if(BUILD_TESTING)
    find_program(FUSE_LOCAL "test/fuse-local.sh" PATHS ${CMAKE_CURRENT_SOURCE_DIR} REQUIRED NO_DEFAULT_PATH)
    find_program(FUSE_REMOTE "test/fuse-remote.sh" PATHS ${CMAKE_CURRENT_SOURCE_DIR} REQUIRED NO_DEFAULT_PATH)
    find_program(EXTENDED_ATTRIBUTES "test/fuse-xattr.sh" PATHS ${CMAKE_CURRENT_SOURCE_DIR} REQUIRED NO_DEFAULT_PATH)
    find_program(OUTPUT_TIMES "test/output-times.sh" PATHS ${CMAKE_CURRENT_SOURCE_DIR} REQUIRED NO_DEFAULT_PATH)

    foreach(t
            unmodified
            create_empty_file
            create_file
            create_executable_file
            append_file
            truncate_file
            fallocate_file
            rename_file
            rename_file_crossdir
            rename_file_noreplace
            rename_file_noreplace_crossdir
            replace_file
            replace_file_crossdir
            remove_file
            create_empty_directory
            create_directory_with_file
            remove_directory
            create_symlink
            create_hardlink
            chown_ctime
            atime
            fifo
            chmod_perms)
        if(SKIP_BUILD_FUSE_CHMOD_PERMS AND t STREQUAL "chmod_perms")
            continue()
        endif()
        add_test(NAME fuse_local_${t} COMMAND ${FUSE_LOCAL} ${t})
        set_property(TEST fuse_local_${t} PROPERTY ENVIRONMENT BUILDBOX=$<TARGET_FILE:buildbox-fuse>)

        if(NOT FUSE_TESTS_SKIP_REMOTE)
            add_test(NAME fuse_remote_${t} COMMAND ${FUSE_REMOTE} ${t})
            set_property(TEST fuse_remote_${t} PROPERTY ENVIRONMENT BUILDBOX=$<TARGET_FILE:buildbox-fuse> CAS_SERVER=$<TARGET_FILE:buildbox-casd>)

            add_test(NAME fuse_prefetch_${t} COMMAND ${FUSE_REMOTE} ${t})
            set_property(TEST fuse_prefetch_${t} PROPERTY ENVIRONMENT BUILDBOX=$<TARGET_FILE:buildbox-fuse> CAS_SERVER=$<TARGET_FILE:buildbox-casd> PREFETCH=1)
        endif()
    endforeach()

    if(NOT FUSE_TESTS_SKIP_XATTR)
        add_test(NAME fuse_extended_attributes COMMAND ${EXTENDED_ATTRIBUTES})
        set_property(TEST fuse_extended_attributes PROPERTY ENVIRONMENT BUILDBOX=$<TARGET_FILE:buildbox-fuse> PROTO_PATH=${CMAKE_SOURCE_DIR}/protos)
    endif()

    add_test(NAME fuse_output_times COMMAND ${OUTPUT_TIMES})
    set_property(TEST fuse_output_times PROPERTY ENVIRONMENT BUILDBOX=$<TARGET_FILE:buildbox-fuse> PROTO_PATH=${CMAKE_SOURCE_DIR}/protos)

    if(NOT FUSE_TESTS_SKIP_REMOTE)
        add_test(NAME fuse_remote_time_output COMMAND ${OUTPUT_TIMES})
        set_property(TEST fuse_remote_time_output PROPERTY ENVIRONMENT BUILDBOX=$<TARGET_FILE:buildbox-fuse> CAS_SERVER=$<TARGET_FILE:buildbox-casd> PREFETCH=1 PROTO_PATH=${CMAKE_SOURCE_DIR}/protos)
    endif()
endif()

=== logstreamreceiver/CMakeLists.txt ===
add_executable(logstreamreceiver logstreamreceiver.m.cpp bytestreamservicer.cpp)
target_precompile_headers(logstreamreceiver REUSE_FROM common)
target_include_directories(logstreamreceiver PRIVATE ".")
target_link_libraries(logstreamreceiver common)
install(TARGETS logstreamreceiver RUNTIME DESTINATION bin COMPONENT logstreamreceiver)

=== logstreamtail/CMakeLists.txt ===
add_executable(logstreamtail logstreamtail.m.cpp logstreamtail.cpp)
target_precompile_headers(logstreamtail REUSE_FROM common)
target_include_directories(logstreamtail PRIVATE ".")
target_link_libraries(logstreamtail common)
install(TARGETS logstreamtail RUNTIME DESTINATION bin COMPONENT logstreamtail)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== outputstreamer/CMakeLists.txt ===
add_executable(outputstreamer outputstreamer.m.cpp)
target_precompile_headers(outputstreamer REUSE_FROM common)
target_include_directories(outputstreamer PRIVATE ".")
target_link_libraries(outputstreamer common)
install(TARGETS outputstreamer RUNTIME DESTINATION bin COMPONENT outputstreamer)

=== debian/changelog ===
buildbox (1.3.53-1) unstable; urgency=low

  * Initial release. Closes: #1127157

 -- Theodore Tucker <theodore@tti0.net>  Tue, 17 Feb 2026 15:32:46 +0000

=== debian/control ===
Source: buildbox
Section: devel
Priority: optional
Maintainer: Theodore Tucker <theodore@tti0.net>
Build-Depends:
 bubblewrap,
 cmake,
 debhelper-compat (= 13),
 help2man,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libgmock-dev,
 libgoogle-glog-dev,
 libgrpc-dev,
 libgrpc++-dev,
 libprotobuf-dev,
 libssl-dev,
 libtomlplusplus-dev,
 nlohmann-json3-dev,
 pkgconf,
 protobuf-compiler-grpc,
 uuid-dev
Standards-Version: 4.7.3
Homepage: https://buildgrid.gitlab.io/buildbox/buildbox/index.html
Vcs-Git: https://salsa.debian.org/tti0/buildbox.git
Vcs-Browser: https://salsa.debian.org/tti0/buildbox

Package: buildbox
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 bubblewrap,
 fuse3
Description: suite of tools for remote build execution
 A suite of clients for remote build execution, conforming to
 the Remote Execution API and the Remote Workers API.
 Includes buildbox-casd, buildbox-fuse, buildbox-run,
 recc and trexe, amongst others.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1
export DEB_CMAKE_ARGS = \
	-DBUILD_TESTING=OFF \
	-DCASD_BUILD_BENCHMARK=OFF \
	-DRUN_USERCHROOT=OFF

export DEB_BUILDBOX_BINARIES = \
	buildbox-casd-wrap \
	buildbox-casd \
	buildbox-fuse \
	buildbox-run-bubblewrap \
	buildbox-run-hosttools \
	buildbox-run-oci \
	buildbox-run \
	buildbox-worker \
	casdownload \
	casupload-oci \
	casupload \
	logstreamreceiver \
	logstreamtail \
	outputstreamer \
	recc \
	rexplorer \
	rumbad \
	trexe

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" $(DEB_CMAKE_ARGS)

execute_after_dh_auto_install:
#	Generate man pages
	for binary in $(DEB_BUILDBOX_BINARIES); do \
		help2man \
		--name=$$binary \
		--no-info \
		--no-discard-stderr \
		--output debian/$$binary.1 \
		debian/buildbox/usr/bin/$$binary ; \
	done
